# This file was auto-generated by Fern from our API Definition.

from ..core.pydantic_utilities import UniversalBaseModel
import pydantic
import typing
import datetime as dt
from .configurable_data_sink_names import ConfigurableDataSinkNames
from .data_sink_create_component import DataSinkCreateComponent
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class DataSink(UniversalBaseModel):
    """
    Schema for a data sink.
    """

    id: str = pydantic.Field()
    """
    Unique identifier
    """

    created_at: typing.Optional[dt.datetime] = pydantic.Field(default=None)
    """
    Creation datetime
    """

    updated_at: typing.Optional[dt.datetime] = pydantic.Field(default=None)
    """
    Update datetime
    """

    name: str = pydantic.Field()
    """
    The name of the data sink.
    """

    sink_type: ConfigurableDataSinkNames
    component: DataSinkCreateComponent = pydantic.Field()
    """
    Component that implements the data sink
    """

    project_id: str

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
