# This file was auto-generated by Fern from our API Definition.

from ..core.pydantic_utilities import UniversalBaseModel
import pydantic
import typing
import datetime as dt
from .embedding_model_config_embedding_config import EmbeddingModelConfigEmbeddingConfig
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class EmbeddingModelConfig(UniversalBaseModel):
    """
    Schema for an embedding model config.
    """

    id: str = pydantic.Field()
    """
    Unique identifier
    """

    created_at: typing.Optional[dt.datetime] = pydantic.Field(default=None)
    """
    Creation datetime
    """

    updated_at: typing.Optional[dt.datetime] = pydantic.Field(default=None)
    """
    Update datetime
    """

    name: str = pydantic.Field()
    """
    The name of the embedding model config.
    """

    embedding_config: EmbeddingModelConfigEmbeddingConfig = pydantic.Field()
    """
    The embedding configuration for the embedding model config.
    """

    project_id: str

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
