# This file was auto-generated by Fern from our API Definition.

from ..core.pydantic_utilities import UniversalBaseModel
import typing
from .supported_llm_model_names import SupportedLlmModelNames
import pydantic
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class EvalExecutionParams(UniversalBaseModel):
    """
    Schema for the params for an eval execution.
    """

    llm_model: typing.Optional[SupportedLlmModelNames] = pydantic.Field(default=None)
    """
    The LLM model to use within eval execution.
    """

    qa_prompt_tmpl: typing.Optional[str] = pydantic.Field(default=None)
    """
    The template to use for the question answering prompt.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
