# This file was auto-generated by Fern from our API Definition.

from ..core.pydantic_utilities import UniversalBaseModel
import pydantic
import typing
from .extract_job_create_data_schema_override import ExtractJobCreateDataSchemaOverride
from .extract_config import ExtractConfig
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class ExtractJobCreate(UniversalBaseModel):
    """
    Schema for creating an extraction job.
    """

    extraction_agent_id: str = pydantic.Field()
    """
    The id of the extraction agent
    """

    file_id: str = pydantic.Field()
    """
    The id of the file
    """

    data_schema_override: typing.Optional[ExtractJobCreateDataSchemaOverride] = pydantic.Field(default=None)
    """
    The data schema to override the extraction agent's data schema with
    """

    config_override: typing.Optional[ExtractConfig] = pydantic.Field(default=None)
    """
    The config to override the extraction agent's config with
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
