# This file was auto-generated by Fern from our API Definition.

from ..core.pydantic_utilities import UniversalBaseModel
import pydantic
import typing
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class LlmModelData(UniversalBaseModel):
    """
    Schema for an eval LLM model.
    """

    name: str = pydantic.Field()
    """
    The name of the LLM model.
    """

    description: str = pydantic.Field()
    """
    The description of the LLM model.
    """

    multi_modal: bool = pydantic.Field()
    """
    Whether the model supports multi-modal image input
    """

    model_name: typing.Optional[str] = None

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
