# This file was auto-generated by Fern from our API Definition.

from __future__ import annotations
from ..core.pydantic_utilities import UniversalBaseModel
from .metadata_filters import MetadataFilters
import pydantic
import typing
from .retriever_pipeline import RetrieverPipeline
from ..core.pydantic_utilities import IS_PYDANTIC_V2
from ..core.pydantic_utilities import update_forward_refs


class RetrieverCreate(UniversalBaseModel):
    name: str = pydantic.Field()
    """
    A name for the retriever tool. Will default to the pipeline name if not provided.
    """

    pipelines: typing.Optional[typing.List[RetrieverPipeline]] = pydantic.Field(default=None)
    """
    The pipelines this retriever uses.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow


update_forward_refs(MetadataFilters, RetrieverCreate=RetrieverCreate)
