# This file was auto-generated by Fern from our API Definition.

from ..core.pydantic_utilities import UniversalBaseModel
import pydantic
import typing
import datetime as dt
from .permission import Permission
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class Role(UniversalBaseModel):
    """
    Schema for a role.
    """

    id: str = pydantic.Field()
    """
    Unique identifier
    """

    created_at: typing.Optional[dt.datetime] = pydantic.Field(default=None)
    """
    Creation datetime
    """

    updated_at: typing.Optional[dt.datetime] = pydantic.Field(default=None)
    """
    Update datetime
    """

    name: str = pydantic.Field()
    """
    A name for the role.
    """

    organization_id: typing.Optional[str] = pydantic.Field(default=None)
    """
    The organization's ID.
    """

    permissions: typing.List[Permission] = pydantic.Field()
    """
    The actual permissions of the role.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
