# This file was auto-generated by Fern from our API Definition.

from ..core.pydantic_utilities import UniversalBaseModel
from .supported_llm_model_names import SupportedLlmModelNames
import pydantic
import typing
from .llm_model_data import LlmModelData
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class SupportedLlmModel(UniversalBaseModel):
    """
    Response Schema for a supported eval LLM model.
    """

    name: SupportedLlmModelNames = pydantic.Field()
    """
    The name of the supported LLM model.
    """

    enabled: typing.Optional[bool] = pydantic.Field(default=None)
    """
    Whether the LLM model is enabled for use in LlamaCloud.
    """

    details: LlmModelData = pydantic.Field()
    """
    The details of the supported LLM model.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
