# This file was auto-generated by Fern from our API Definition.

from ..core.pydantic_utilities import UniversalBaseModel
import typing
import pydantic
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class TokenTextSplitter(UniversalBaseModel):
    """
    Implementation of splitting text that looks at word tokens.
    """

    include_metadata: typing.Optional[bool] = pydantic.Field(default=None)
    """
    Whether or not to consider metadata when splitting.
    """

    include_prev_next_rel: typing.Optional[bool] = pydantic.Field(default=None)
    """
    Include prev/next node relationships.
    """

    callback_manager: typing.Optional[typing.Optional[typing.Any]] = None
    id_func: typing.Optional[str] = pydantic.Field(default=None)
    """
    Function to generate node IDs.
    """

    chunk_size: typing.Optional[int] = pydantic.Field(default=None)
    """
    The token chunk size for each chunk.
    """

    chunk_overlap: typing.Optional[int] = pydantic.Field(default=None)
    """
    The token overlap of each chunk when splitting.
    """

    separator: typing.Optional[str] = pydantic.Field(default=None)
    """
    Default separator for splitting into words
    """

    backup_separators: typing.Optional[typing.List[typing.Optional[typing.Any]]] = pydantic.Field(default=None)
    """
    Additional separators for splitting.
    """

    class_name: typing.Optional[str] = None

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
